-- View scripts 
-- Copyright (C) 2004, Eagle Dynamics.

-- Don't change existing values, they are requested from �++!
-- Use these indices in Snap and CockpitLocalPoint tables.
dofile("Scripts/Database/wsTypes.lua")

function validate(tbl,itype)
	local default = Su_27
	if itype > 150 then --LastPlaneType
	   default = KA_50
	end
    return tbl[itype] or tbl[default]
end

DisableCombatViews = false -- F5 & Ctrl-F5
ExternalObjectsLockDistance = 10000.0
ShowTargetInfo = false
CameraTerrainRestriction = true

CockpitLocalPoint = {}
CockpitLocalPoint[Su_27]   = {8.15 , 1.38 , 0.0}
CockpitLocalPoint[Su_33]   = {8.35 , 1.35 , 0.0}
CockpitLocalPoint[Su_25] = {3.5 , 0.4 , 0.0}
CockpitLocalPoint[Su_25T]  = {3.406, 0.466, 0.0}
CockpitLocalPoint[MiG_29]  = {4.92 , 1.35 , 0.0}
CockpitLocalPoint[MIG_29K] = {4.9  , 1.254, 0.0}
CockpitLocalPoint[A_10A]   = {4.3  , 1.282, 0.0}
CockpitLocalPoint[F_15]    = {6.5  , 1.238, 0.0}
CockpitLocalPoint[KA_50]   = {3.188, 0.39 , 0.0}
CockpitLocalPoint[A_10C]   = CockpitLocalPoint[A_10A]

EyePoint = {}
EyePoint[Su_27]   = {0,0,0}
EyePoint[Su_33]   = {0,0,0}
EyePoint[Su_25]   = {0,0,0}
EyePoint[Su_25T]  = {0,0,0}
EyePoint[MiG_29]  = {0,0,0}
EyePoint[MIG_29K] = {0,0,0}
EyePoint[F_15]    = {0,0,0}
EyePoint[A_10A]   = {0,0,0}
EyePoint[KA_50]   = {0.09, 0, 0}
EyePoint[A_10C]   = EyePoint[A_10A]

limits_6DOF = {}
limits_6DOF[Su_27]   = {x = {0,0},y = {0,0},z = {0,0},roll = 0}
limits_6DOF[Su_33]   = {x = {0,0},y = {0,0},z = {0,0},roll = 0}
limits_6DOF[Su_25]   = {x = {0,0},y = {0,0},z = {0,0},roll = 0}
limits_6DOF[Su_25T]  = {x = {0,0},y = {0,0},z = {0,0},roll = 0}
limits_6DOF[MiG_29]  = {x = {0,0},y = {0,0},z = {0,0},roll = 0}
limits_6DOF[MIG_29K] = {x = {0,0},y = {0,0},z = {0,0},roll = 0}
limits_6DOF[F_15]    = {x = {0,0},y = {0,0},z = {0,0},roll = 0}
limits_6DOF[A_10A]   = {x = {-0.02,0.7 } ,y = {-0.15,0.35},z = {-0.26,0.26},roll = 90.0}
limits_6DOF[KA_50]   = {x = {-0.02,0.35} ,y = {-0.15,0.165},z = {-0.17,0.17},roll = 90.0}
limits_6DOF[A_10C]   = {x = {-0.05,0.6},y = {-0.3,0.1},z = {-0.25,0.25},roll = 90}

function GetCockpitLocalPoint(iType)
    local p = validate(CockpitLocalPoint,iType)
    return p[1], p[2], p[3]
end

function GetEyePoint(iType)
    local p = validate(EyePoint,iType)
    return p[1], p[2], p[3]
end

function Get_6DOF_limits(iType)
    local p = validate(limits_6DOF,iType)
    return p.x[1],
           p.x[2],
           p.y[1],
           p.y[2],
           p.z[1],
           p.z[2],
           p.roll
end

function SetCockpitLocalPoint(iType, x, y, z)
	CockpitLocalPoint[iType] = {x,y,z}
end

-- Camera angle limits {horizontal angle max, vertical angle min, vertical angle max}
CameraAngleLimits = {}
CameraAngleLimits[Su_27] = {140.0, -75.0, 90.0}
CameraAngleLimits[Su_33] = {140.0, -75.0, 90.0}
CameraAngleLimits[Su_25] = {95.0, -65.0, 90.0}
CameraAngleLimits[Su_25T] = {110.0, -80.0, 90.0}
CameraAngleLimits[MiG_29] = {140.0, -75.0, 90.0}
CameraAngleLimits[MIG_29K] = {140.0, -65.0, 90.0}
CameraAngleLimits[A_10A] = {140.0, -65.0, 90.0}
CameraAngleLimits[F_15] = {140.0, -80.0, 90.0}
CameraAngleLimits[KA_50] ={140.0, -65.0, 90.0}
CameraAngleLimits[A_10C] = CameraAngleLimits[A_10A]

CameraAngleRestriction = {}
CameraAngleRestriction[Su_27]   =  {1,60,0.4}
CameraAngleRestriction[Su_33]   =  {1,60,0.4}
CameraAngleRestriction[Su_25]   =  {1,60,0.4}
CameraAngleRestriction[Su_25T]  =  {1,60,0.4}
CameraAngleRestriction[MiG_29]  =  {1,60,0.4}
CameraAngleRestriction[MIG_29K] =  {1,60,0.4}
CameraAngleRestriction[F_15]    =  {1,60,0.4}

CameraAngleRestriction[A_10A] =  {0,90,0.5}
CameraAngleRestriction[KA_50] =  {0,60,0.4}
CameraAngleRestriction[A_10C] = CameraAngleRestriction[A_10A]

function GetCameraAngleLimits(iType)
    local p = validate(CameraAngleLimits,iType)
    return p[1], p[2], p[3]
end

function GetCameraAngleRestriction(iType)
    local p = validate(CameraAngleRestriction,iType)
    return  p[1], p[2], p[3]
end 

function SetCameraAngleLimits(iType, hAngMax, vAngMin, vAngMax)
    local p = validate(CameraAngleLimits,iType)
    p[1] = hAngMax
    p[2] = vAngMin
    p[3] = vAngMax
end

-- Following values will not be saved in tracks in the current version!
hAngleRearDefault =  180
vAngleRearDefault = -8.0
vAngleRearMin     = -90 -- -8.0
vAngleRearMax     = 90.0

RearCameraPos = {}
RearCameraAnglesDefault = {}
ArcadeCameraPos = {}
ArcadeCameraAnglesDefault = {}

for i,o in pairs(CockpitLocalPoint) do
    RearCameraAnglesDefault[i]   =  {180,-8.0} 
    RearCameraPos[i]             =  {o[1] - 3.7 ,o[2] + 2.4, o[3]}
    ArcadeCameraAnglesDefault[i] =  {0  ,-8.0}
    ArcadeCameraPos[i]           =  {o[1] - 20  ,o[2] + 5  , o[3] + 0}  
end


ArcadeCameraPos[A_10C]           = {-27, 12, 0}
ArcadeCameraAnglesDefault[A_10C] =  {0, -12.0}


function GetRearCameraPosition(iType)
    local  p = validate(RearCameraPos,iType)
    return p[1], p[2], p[3]
end

function GetRearCameraAnglesDefault(iType)
    local p = validate(RearCameraAnglesDefault,iType)
    if p == nil then    return hAngleRearDefault , vAngleRearDefault
    else                return p[1], p[2]    end
end


function GetArcadeCameraPosition(iType)
    local  p = validate(ArcadeCameraPos,iType)
    return p[1], p[2], p[3]
end

function GetArcadeCameraAnglesDefault(iType)
    local p = validate(ArcadeCameraAnglesDefault,iType)
    if p == nil then    return hAngleRearDefault , vAngleRearDefault
    else                return p[1], p[2]    end
end

dbg_shell    = "weapons.shells.GAU8_30_AP" -- 23mm shell
-- dbg_shell    = "weapons.shells.2A64_152" -- 152mm shell
dbg_shell_v0 = -1 -- Muzzle speed m/s (-1 - speed from shall database)